<?php

namespace Payshop\Core\Gateway\Authorize\Request;

use Magento\Framework\App\RequestInterface;
use Magento\Payment\Gateway\Request\BuilderInterface;
use Magento\Payment\Gateway\Data\PaymentDataObjectInterface;

class InstrumentRequest implements BuilderInterface
{
    /**
     * @var RequestInterface
     */
    private RequestInterface $request;

    /**
     * InstrumentRequest constructor.
     * 
     * @param RequestInterface $request
     */
    public function __construct(
        RequestInterface $request
    ) {
        $this->request = $request;
    }

    /**
     * build instrument request
     * 
     * @param array $buildSubject
     * @return array
     */
    public function build(array $buildSubject)
    {
        if (!isset($buildSubject['payment'])
            || !$buildSubject['payment'] instanceof PaymentDataObjectInterface
        ) {
            throw new \InvalidArgumentException('Payment data object should be provided');
        }

        $instrumentId = $this->request->getParam('instrumentId');
    
        if (!$instrumentId) {
            throw new \InvalidArgumentException('Instrument ID is missing');
        }

        return [
            'instrumentId' => $instrumentId
        ];
    }
}
