<?php

namespace Payshop\Core\Gateway\Authorize\Validator;

use Magento\Payment\Gateway\Validator\AbstractValidator;

class ResponseValidator extends AbstractValidator
{
    /**
     * @inheritDoc
     */
    public function validate(array $validationSubject)
    {
        if (!isset($validationSubject['response']) || !is_array($validationSubject['response'])) {
            throw new \InvalidArgumentException('Response does not exist');
        }
        $response = $validationSubject['response'];

        if ($this->isSuccessfulTransaction($response)) {
            return $this->createResult(
                true,
                []
            );
        } else {
            return $this->createResult(
                false,
                [],
                [$response['code']]
            );
        }
    }

    /**
     * Check if transaction is successful
     * 
     * @param array $response
     * @return bool
     */
    private function isSuccessfulTransaction(array $response): bool
    {
       return $response['status'] !== 'error';
    }
}
